//--------------------------------------------------------------------//
/**
 * Uq^NX
 */
public class PendulumMotion{

/** Runge - Kutta - Gill @̌W 1 */
  public static final double
    C1[]={0.16666667,0.09763107,0.56903559,0.16666667};

/** Runge - Kutta - Gill @̌W 2 */
  public static final double
    C2[][]={{0.0},{0.5},{0.20710678,0.29289322},
      	    {0.0,-0.70710678,1.70710678}};

//--------------------------------------------------------------------//
/**
 * Uq̎Ԃ
 * @param length Uq
 * @param g d͉x
 * @param theta px
 */
  public static double period(double length,double g,double theta){
    double k=Math.sin(0.5*theta);
    return 4.0*Math.sqrt(length/g)*Ellipse.ellipseInt1(k);
  }

//--------------------------------------------------------------------//
/**
 * Runge - Kutta - Gill @ŐUq^̎̃^CXebvvZ
 * @param dt ԑ
 * @param cv x
 * @param motion Uq^
 */
  public static void nextRKG(double dt,double cv,Motion motion){
    double dx[]=new double[4];
    double dv[]=new double[4];
    double x=0.0;
    double v=0.0;
    for(int i=0;i<4;i++){
      double sx=0.0;
      double sv=0.0;
      for(int j=0;j<i;j++){
      	sx+=C2[i][j]*dx[j];
      	sv+=C2[i][j]*dv[j];
      }
      dx[i]=dt*(motion.omega+sv);
      dv[i]=-cv*Math.sin(motion.theta+sx);
      x+=C1[i]*dx[i];
      v+=C1[i]*dv[i];
    }
    motion.add(dt,x,v);
  }
}
